oms = {}
oms.players = {};
oms.playerUnitNames = {};
oms.challenger = 'No Unit'

function oms.updatePlayerUnits()
	if #oms.players == 0 then
		oms.playerUnitNames = mist.getUnitsByAttribute({skill = 'Client'})
	else
		oms.playerUnitNames = mist.makeUnitTable(oms.players)
	end
	--trigger.action.outText('玩家列表人数  '..#oms.playerUnitNames,1)
end

function oms.getUnitNames(UNT)
	local unitNames
	if UNT then
		unitNames = mist.makeUnitTable(UNT)
	else
		unitNames = oms.playerUnitNames
	end
	return unitNames
end

function oms.getUnitIDs(unitNames, zoneNames)
	local unitIDs = {}
	if zoneNames then
		unitIDs = mist.getUnitsInZones(unitNames, zoneNames)
	else
		for i = 1, #unitNames do
			local u = Unit.getByName(unitNames[i])
			if u then
				unitIDs[i] = u
			end
		end
	end
	return unitIDs
end

function oms.validFlagVal(value)
	value = math.floor(value + 0.5)
	if value <= 1 then
		value = 1
	end
	return value
end

function oms.validFlagHdg(hdg)
	hdg = math.floor(hdg + 0.5)
	if hdg < 0 then
		hdg = hdg + 360
	elseif hdg == 0 then
		hdg = 360
	end
	return hdg
end

function oms.inZone(zoneNames, flag, UNT)
	flag = flag or 'omsNilFlag'
	local unitNames = oms.getUnitNames(UNT)
	local unitsInZone = mist.getUnitsInZones(unitNames, zoneNames)
	trigger.action.setUserFlag(tostring(flag), #unitsInZone)
	return #unitsInZone
end

function oms.inMvZone(zoneUnitNames, zoneRadius, zoneType, flag, UNT)
	flag = flag or 'omsNilFlag'
	local unitNames = oms.getUnitNames(UNT)
	local unitsInZone = mist.getUnitsInMovingZones(unitNames, zoneUnitNames, zoneRadius, zoneType)
	trigger.action.setUserFlag(tostring(flag), #unitsInZone)
	return #unitsInZone
end

function oms.maxASL(flag, zoneNames, UNT)
	flag = flag or 'omsNilFlag'
	local unitNames = oms.getUnitNames(UNT)
	local unitIDs = oms.getUnitIDs(unitNames, zoneNames)
	local maxAlt = 0
	if #unitIDs > 0 then 
		for i = 1, #unitIDs do
			local pos = unitIDs[i]:getPosition().p
			if pos.y > maxAlt then
				maxAlt = pos.y
			end
		end
		maxAlt = oms.validFlagVal(maxAlt * 3.28084)
	end
	trigger.action.setUserFlag(tostring(flag), maxAlt)
	return maxAlt
end

function oms.minASL(flag, zoneNames, UNT)
	flag = flag or 'omsNilFlag'
	local unitNames = oms.getUnitNames(UNT)
	local unitIDs = oms.getUnitIDs(unitNames, zoneNames)
	--trigger.action.outText(tostring(#unitIDs),1)
	local minAlt = 10000000
	if #unitIDs > 0 then 
		for i = 1, #unitIDs do
			local pos = unitIDs[i]:getPosition().p
			if pos.y < minAlt then
				minAlt = pos.y
			end
		end
		minAlt = oms.validFlagVal(minAlt * 3.28084)
	end
	if minAlt == 10000000 then
		minAlt = 0
	end
	trigger.action.setUserFlag(tostring(flag), minAlt)
	return minAlt
end


function oms.inAir(flag, zoneNames, UNT)
	flag = flag or 'omsNilFlag'
	local unitNames = oms.getUnitNames(UNT)
	local unitIDs = oms.getUnitIDs(unitNames, zoneNames)
	local n = 0
	if #unitIDs > 0 then
		for i = 1, #unitIDs do
			if unitIDs[i]:inAir() then
				n = n + 1;
			end
		end
	end
	trigger.action.setUserFlag(tostring(flag), n)
	return n
end


function oms.onGnd(flag, zoneNames, UNT)
	flag = flag or 'omsNilFlag'
	local unitNames = oms.getUnitNames(UNT)
	local unitIDs = oms.getUnitIDs(unitNames, zoneNames)
	local n = 0
	if #unitIDs > 0 then
		for i = 1, #unitIDs do
			if not unitIDs[i]:inAir() then
				n = n + 1;
			end
		end
	end
	trigger.action.setUserFlag(tostring(flag), n)
	return n
end

function oms.signUp(zoneNames, flag, UNT)
	flag = flag or 'omsNilFlag'
	local unitNames = oms.getUnitNames(UNT)
	local u
	local name
	local unitsInZone = mist.getUnitsInZones(unitNames, zoneNames)
	if #unitsInZone == 1 then
		trigger.action.setUserFlag(tostring(flag), 1)
		name = Unit.getName(unitsInZone[1])
	elseif #unitsInZone > 1 then
		trigger.action.setUserFlag(tostring(flag), 2)
		name = 'Too Many'
	else
		trigger.action.setUserFlag(tostring(flag), 0)
		name = 'No Unit'
	end
	oms.challenger = name
	return name
end

function oms.signUpMv(zoneUnitNames, zoneRadius, zoneType, flag, UNT)
	flag = flag or 'omsNilFlag'
	local unitNames = oms.getUnitNames(UNT)
	local name
	local unitsInZone = mist.getUnitsInMovingZones(unitNames, zoneUnitNames, zoneRadius, zoneType)
	if #unitsInZone == 1 then
		trigger.action.setUserFlag(tostring(flag), 1)
		name = Unit.getName(unitsInZone[1])
	elseif #unitsInZone > 1 then
		trigger.action.setUserFlag(tostring(flag), 2)
		name = 'Too Many'
	else
		trigger.action.setUserFlag(tostring(flag), 0)
		name = 'No Unit'
	end
	oms.challenger = name
	return name
end

function oms.unitASL(flag, name)
	flag = flag or 'omsNilFlag'
	name = name or oms.challenger
	local unitAlt = 0
	local u = Unit.getByName(name)
	if u then
		local pos = u:getPosition().p
		unitAlt = oms.validFlagVal(pos.y * 3.28084)
	end
	trigger.action.setUserFlag(tostring(flag), unitAlt)
	return unitAlt
end

function oms.unitSpeed(flag, name)
	flag = flag or 'omsNilFlag'
	name = name or oms.challenger
	local unitSpeed = 0
	local u = Unit.getByName(name)
	if u then
		local vel = u:getVelocity()
		local spd = math.sqrt(vel.x^2 + vel.y^2 + vel.z^2)
		unitSpeed = oms.validFlagVal(spd * 1.94384449)
	end
	trigger.action.setUserFlag(tostring(flag), unitSpeed)
	return unitSpeed
end

function oms.unitGndSpeed(flag, name)
	flag = flag or 'omsNilFlag'
	name = name or oms.challenger
	local unitSpeed = 0
	local u = Unit.getByName(name)
	if u then
		local vel = u:getVelocity()
		local spd = math.sqrt(vel.x^2 + vel.z^2)
		unitSpeed = oms.validFlagVal(spd * 1.94384449)
	end
	trigger.action.setUserFlag(tostring(flag), unitSpeed)
	return unitSpeed
end

function oms.unitClimbRate(flag, name)
	flag = flag or 'omsNilFlag'
	name = name or oms.challenger
	local unitSpeed = 0
	local u = Unit.getByName(name)
	if u then
		local vel = u:getVelocity()
		local spd = vel.y
		unitSpeed = oms.validFlagVal(spd * 196.850394)
	end
	trigger.action.setUserFlag(tostring(flag), unitSpeed)
	return unitSpeed
end

function oms.unitDiveRate(flag, name)
	flag = flag or 'omsNilFlag'
	name = name or oms.challenger
	local unitSpeed = 0
	local u = Unit.getByName(name)
	if u then
		local vel = u:getVelocity()
		local spd = -vel.y
		unitSpeed = oms.validFlagVal(spd  * 196.850394)
	end
	trigger.action.setUserFlag(tostring(flag), unitSpeed)
	return unitSpeed
end

function oms.unitClimbAngle(flag, name)
	flag = flag or 'omsNilFlag'
	name = name or oms.challenger
	local unitSpeed = 0
	local u = Unit.getByName(name)
	if u then
		local vel = u:getVelocity()
		local AbsSpd = math.sqrt(vel.x^2 + vel.y^2 + vel.z^2)
		local VrtSpd = vel.y
		local angle = math.deg(math.asin(VrtSpd/AbsSpd))
		unitSpeed = oms.validFlagVal(spd)
	end
	trigger.action.setUserFlag(tostring(flag), unitSpeed)
	return unitSpeed
end

function oms.unitDiveAngle(flag, name)
	flag = flag or 'omsNilFlag'
	name = name or oms.challenger
	local unitSpeed = 0
	local u = Unit.getByName(name)
	if u then
		local vel = u:getVelocity()
		local AbsSpd = math.sqrt(vel.x^2 + vel.y^2 + vel.z^2)
		local VrtSpd = -vel.y
		local angle = math.deg(math.asin(VrtSpd/AbsSpd))
		unitSpeed = oms.validFlagVal(spd)
	end
	trigger.action.setUserFlag(tostring(flag), unitSpeed)
	return unitSpeed
end

function oms.unitHeading(flag, name)
	flag = flag or 'omsNilFlag'
	name = name or oms.challenger
	local hdg = 0
	local u = Unit.getByName(name)
	if u then
		hdg = math.deg(mist.getHeading(u))
		hdg = oms.validFlagHdg(hdg)
	end
	trigger.action.setUserFlag(tostring(flag), hdg)
	return hdg
end

function oms.headingDiff(name1, name2, flag)
	flag = flag or 'omsNilFlag'
	local hdgDiff = 0
	local u1 = Unit.getByName(name1)
	local u2 = Unit.getByName(name2)
	if u1 and u2 then
		local hdg1 = math.deg(mist.getHeading(u1))
		local hdg2 = math.deg(mist.getHeading(u2))
		hdgDiff = hdg2 - hdg1
		if hdgDiff > 180 then
			hdgDiff = hdgDiff - 360
		elseif hdgDiff < -180 then
			hdgDiff = hdgDiff + 360
		end
		hdgDiff = math.floor(hdgDiff + 0.5)
		hdgDiffRel = hdgDiff
		if hdgDiff == 0 then
			hdgDiff = 1
		end
	end
	trigger.action.setUserFlag(tostring(flag), math.abs(hdgDiff))
	return hdgDiffRel
end

function oms.randFlag(flag, lowerBound, upperBound)
	flag = flag or 'omsNilFlag'
	lowerBound = lowerBound or 1
	upperBound = upperBound or 100
	num = math.random(lowerBound, upperBound)
	num = oms.validFlagVal(num)
	trigger.action.setUserFlag(tostring(flag), num)
	return num
end

function oms.randTimer(flag, lowerBound, upperBound)
	flag = flag or 'omsNilFlag'
	lowerBound = lowerBound or 1
	upperBound = upperBound or 100
	dt = math.random(lowerBound, upperBound)
	dt = oms.validFlagVal(dt)
	mist.scheduleFunction(trigger.action.setUserFlag, {tostring(flag), 1}, timer.getTime() + dt)
end

mist.scheduleFunction(oms.updatePlayerUnits, {}, timer.getTime() + 1.5, 30)